//+------------------------------------------------------------------+
//|                                            vic_bouncingPipEA.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern double Lots=0.01;
extern int    Tp=10;
extern int    Wick=0;


int init()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
bool Body_Wick(int shift){
   bool auxValue=false;
   double body,bottomWick,topWick;
   double open,close,high,low;
   
   open=iOpen(Symbol(),Period(),shift);
   close=iClose(Symbol(),Period(),shift);
   low=iLow(Symbol(),Period(),shift);
   high=iHigh(Symbol(),Period(),shift);
   
   if (open < close){ //up candle
      topWick=high-close;
      body=close-open;
      bottomWick=open-low;
   }
   else{ //down candle
      topWick=high-open;
      body=open-close;
      bottomWick=close-low; 
   }
   
   
   if ((topWick > Wick*body) || (bottomWick > Wick*body)){
      auxValue=true;
   }
   
   
   return (auxValue);
}



int start()
  {
//----
   static datetime dtBarTime = 0;
   static int ticket; 
   double ZigZagUp,ZigZagDown;
   double NonLagZigZag;
   double PriceChannelStopUp,PriceChannelStopDown;
   
   if (dtBarTime == Time[0]) return(0);  
   dtBarTime = Time[0];
   
   NonLagZigZag=iCustom(NULL,0,"NonLagZigZag_v2",0,1);   
   
   ZigZagUp=iCustom(NULL,0,"ZigZag Pointer",0,1);
   ZigZagDown=iCustom(NULL,0,"ZigZag Pointer",1,1);
   
   PriceChannelStopUp=iCustom(NULL,0,"PriceChannel_Stop_v1",0,0);
   PriceChannelStopDown=iCustom(NULL,0,"PriceChannel_Stop_v1",1,0);
   
   //Alert("nonlag: ",NonLagZigZag," zup: ".ZigZagUp, " zdown: ",ZigZagDown);
    
    if(OrderSelect(ticket, SELECT_BY_TICKET)==true){         
          
         //if (OrderProfit() > 10){
        
            if (OrderType() == OP_BUY){               
            
               if ((Ask-OrderOpenPrice())> Tp*Point){
                  //Alert("Victor buy: ",Ask-OrderOpenPrice());
                  OrderModify(OrderTicket(),OrderOpenPrice(),PriceChannelStopUp,OrderTakeProfit(),0,Red);                 
               }
            }
            if (OrderType() == OP_SELL){
               if ((OrderOpenPrice() - Bid)> Tp*Point){
                  //Alert(" Victor sell: ",OrderOpenPrice() - Bid);
                  OrderModify(OrderTicket(),OrderOpenPrice(),PriceChannelStopDown,OrderTakeProfit(),0,Red);
               }
            }
        
         //}
    }
   
   
   if ((ZigZagDown != 0) && (ZigZagDown == NonLagZigZag)){ //down arrow & nonlag
     
      if(OrderSelect(ticket, SELECT_BY_TICKET)==true){         
         if (OrderType() == OP_BUY){
            OrderClose(ticket,Lots,Ask,3,Red);
         }
      }
      
      if (Body_Wick(1) == true){ //if body is smaller than the wick
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,iHigh(Symbol(),Period(),1)+(MarketInfo(Symbol(),MODE_SPREAD)+1)*Point,0,"",2,0,Red);      
      }
   }
   
   
   if ((ZigZagUp != 0) && (ZigZagUp == NonLagZigZag)){ //up arrow & nonlag

      if(OrderSelect(ticket, SELECT_BY_TICKET)==true){         
         if (OrderType() == OP_SELL){
            OrderClose(ticket,Lots,Bid,3,Green);            
         }
      }
      
      if (Body_Wick(1) == true){ //if body is smaller than the wick
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,iLow(Symbol(),Period(),1)-(MarketInfo(Symbol(),MODE_SPREAD)+1)*Point,0,"",1,0,Green);
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+